//
//  AppDelegate.m
//  YiXinSDKSample
//
//  Version 1.2
//  Created by yixin ( yixinopen@188.com )
//  Copyright (c) 2013年 yixin.im All rights reserved.
//

#import "OauthTestAppDelegate.h"
#import "YXApi.h"


#define kYixinOAuthURI @"https://open.yixin.im/oauth/authorize"
#define kMyAppRedirectURIforYixin @"http://photo.163.com"
#define kMyAppRedirectURIDefaultforYixin @"https://open.yixin.im/resource/oauth2_callback.html"

#warning 注意这里替换成您申请的key信息
#define kYixinKey        @"yxbbd0e8b3dce64e02bab42437becc4384"
#define kYixinSecret     @""

@implementation OauthTestAppDelegate

- (void)dealloc
{
    [_window release];
    [_viewController release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    
    [YXApi registerApp:kYixinKey];
    
    self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // Override point for customization after application launch.
    self.viewController = [[[OauthTestViewController alloc] initWithNibName:@"OauthTestViewController" bundle:nil] autorelease];
    [self.viewController setDelegate:self];
    self.window.rootViewController = self.viewController;
    [self.window makeKeyAndVisible];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

#pragma mark -
#pragma mark - YixinAPI use
- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url
{
    return  [YXApi handleOpenURL:url delegate:self];
}

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation
{
    return  [YXApi handleOpenURL:url delegate:self];
}

#pragma mark -
#pragma mark - YXApiDelegate method
- (void)onReceiveRequest: (YXBaseReq *)req {
    
}

//易信app再获得oauth服务器响应之后会将相关结果通过该方法回传
- (void)onReceiveResponse: (YXBaseResp *)resp
{
    if([resp isKindOfClass:[SendMessageToYXResp class]])
    {
        SendMessageToYXResp *sendResp = (SendMessageToYXResp *)resp;
        NSLog(@"%ld, %@", (long)sendResp.code, sendResp.errDescription);
    }else if([resp isKindOfClass:[SendOAuthToYXResp class]]){//kYXOAuthMessageResp
        if(resp.code == kYXRespSuccess){
            SendOAuthToYXResp *oauthresp = (SendOAuthToYXResp *)resp;
            NSString *oauthcode = [NSString stringWithFormat:@"oauthcode:%@", oauthresp.authCode];
            [self updateOauthCode:oauthcode];
        }else{
            [self showAlert:[NSString stringWithFormat:@"oauth失败：\t%@", resp.errDescription]];
        }
    }
}

//pragma mark -
//pragma mark - YXViewDelegate method end



//获取oauthURL
- (NSString *) getYixinOAuthReqURIstr
{
    NSString *reqUri = [NSString stringWithFormat:@"%@?response_type=%@&client_id=%@&redirect_url=%@&state=demoOAuth&scope=", kYixinOAuthURI, @"code", kYixinKey, kMyAppRedirectURIforYixin];
    return reqUri;
}

- (BOOL) isYixinOAuthCallbackURL : (NSString *)url
{
    return [url hasPrefix:kMyAppRedirectURIforYixin] || [url hasPrefix: kMyAppRedirectURIDefaultforYixin];
}

- (void) parseYixinOAuthCallbackURI:(NSString *)url
{
    //找到”code=“的range
    NSRange rangeOne;
    rangeOne=[url rangeOfString:@"?"];
    NSRange range = NSMakeRange(rangeOne.length+rangeOne.location, url.length-(rangeOne.length+rangeOne.location));
    NSString *codeString = [url substringWithRange:range];
    [self updateOauthCode:codeString];
}


//发送oauthcode请求
- (void)sendOauthCodeReq
{
    int statuCode = [self isYXSurpport];
    NSString *msg = nil;
    if(statuCode == -1){
       msg = @"未安装易信，请使用webview进行认证或者提示用户下载安装最新版易信";
    }else if(statuCode == 0){
       msg = @"易信版本不支持，请下载最新版或者webview进行认证";
    }
    if(statuCode != 1){
        [self showAlert:msg];
        return;
    }
    SendOAuthToYXReq *req = [[[SendOAuthToYXReq alloc] init] autorelease];
    bool result = [YXApi sendReq : req];
    if(!result){
        [self showAlert: @"请求失败"];
    }
}

//更新主界面的oauthcode
- (void) updateOauthCode : (NSString *)oauthCode
{
    [self.viewController updateOauthCode: oauthCode];
}
//检测易信端是否支持
- (int) isYXSurpport {
    bool isYXAppInstalled = [YXApi isYXAppInstalled];
    bool isYXAppSupportOAuth = [YXApi isYXAppSupportOAuth];
    if(!isYXAppInstalled){
        return -1;
    }else{
        if(!isYXAppSupportOAuth){
            return 0;
        }
    }
    return 1;
}


- (void)showAlert: (NSString *)msg
{
    if(msg){
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"信息提示" message:msg delegate:nil cancelButtonTitle:@"ok" otherButtonTitles:nil];
        [alert show];
        [alert release];
    }
}

@end
